#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/gfp.h>

#define PAGES_ORDER_REQUESTED 3
#define INTS_IN_PAGE (PAGE_SIZE / sizeof(int))

unsigned long virt_addr;

static int __init low_level_memory_allocator_kernel_module_init(void)
{
  int *int_array;
  int i;

  printk("low_level_memory_allocator_kernel_module_init()\n");
  virt_addr = __get_free_pages(GFP_KERNEL, PAGES_ORDER_REQUESTED);

  if (!virt_addr) {
    printk("Error in allocation\n");
    return -1;
  }

  int_array = (int *) virt_addr;

  for (i = 0; i < INTS_IN_PAGE; i++) {
    int_array[i] = i;
  }

  for (i = 0; i < INTS_IN_PAGE; i++) {
    printk("array[%d] = %d\n", i, int_array[i]);
  }

  return 0;
}

static void __exit low_level_memory_allocator_kernel_module_exit(void)
{
  printk("low_level_memory_allocator_kernel_module_exit()\n");
  free_pages(virt_addr, PAGES_ORDER_REQUESTED);
}

module_init(low_level_memory_allocator_kernel_module_init);
module_exit(low_level_memory_allocator_kernel_module_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Hiroyuki Chishiro");
MODULE_DESCRIPTION("Low-Level Memory Allocator Kernel Module");
